package net.knarcraft.hungerarena.Listeners;

import net.knarcraft.hungerarena.HungerArena;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.entity.Projectile;
import org.bukkit.entity.Skeleton;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDamageEvent;

public class PvP implements Listener {
    public final HungerArena plugin;

    public PvP(HungerArena m) {
        this.plugin = m;
    }

    int arenaId = 0;

    @EventHandler(priority = EventPriority.MONITOR)
    public void PlayerPvP(EntityDamageByEntityEvent event) {
        Entity pl = event.getEntity();
        Entity dl = event.getDamager();
        if (pl instanceof Player p && dl instanceof Player d) {
            if (plugin.getArena(p) != null && plugin.getArena(d) != null) {
                arenaId = plugin.getArena(p).getArenaId();
                if (plugin.canJoin.get(arenaId)) {
                    if (event.isCancelled()) {
                        event.setCancelled(false);
                    }
                    if (plugin.gp.get(plugin.getArena(p)) != null) {
                        if (plugin.gp.get(plugin.getArena(p)) != 0) {
                            event.setCancelled(true);
                        }
                    }
                }
            }
            if (plugin.getArena(p) != null) {
                arenaId = plugin.getArena(p).getArenaId();
                if (!plugin.canJoin.get(arenaId)) {
                    if (!event.isCancelled()) {
                        event.setCancelled(true);
                    }
                }
            }
            if (plugin.getArena(p) == null && plugin.getArena(d) != null) {
                if (!event.isCancelled()) {
                    event.setCancelled(true);
                }
            }
        } else if (pl instanceof Player p && dl instanceof Projectile projectile) {
            if (projectile.getShooter() instanceof Player) {
                if (plugin.getArena(p) != null) {
                    Player shooter = (Player) projectile.getShooter();
                    if (plugin.getArena(shooter) != null) {
                        if (plugin.gp.get(plugin.getArena(p)) != null) {
                            event.setCancelled(plugin.gp.get(plugin.getArena(p)) != 0);
                        }
                    }
                }
            } else if (projectile.getShooter() instanceof Entity e) {
                if (e instanceof Skeleton) {
                    if (plugin.getArena(p) != null) {
                        if (plugin.gp.get(plugin.getArena((Player) e)) != null) {
                            event.setCancelled(plugin.gp.get(plugin.getArena(p)) != 0);
                        }
                    }
                }
            }
        }
    }

    @EventHandler
    public void PlayerDamage(EntityDamageEvent event) {
        Entity e = event.getEntity();
        if (e instanceof Player player) {
            if (plugin.getArena(player) != null) {
                arenaId = plugin.getArena(player).getArenaId();
                if (plugin.gp.get(arenaId) != null && plugin.gp.get(arenaId) != 0) {
                    event.setCancelled(true);
                }
                if (plugin.arenaPlayers.get(player.getUniqueId()).isFrozen()) {
                    event.setCancelled(true);
                }
            }
        }
    }

}
